#pragma once
#include <Arduino.h>
#include <TFT_eSPI.h>

// Code adapted from
// https://www.jagregory.com/abrash-black-book/#chapter-17-the-game-of-life
class CellMap {
 private:
  uint8_t width;
  uint8_t height;
  uint8_t scale;

  uint16_t byte_total_length;
  uint16_t byte_width;

  uint8_t* cells;  // Each unsigned int represents 8 continuous cells


 public:
  CellMap(uint8_t h, uint8_t w, uint8_t s, TFT_eSprite* tft);
  ~CellMap();
  void reset();
  void copy_cells(CellMap& source);
  void set_cell(uint8_t x, uint8_t y);
  void clear_cell(uint8_t x, uint8_t y);
  uint8_t cell_state(uint8_t x, uint8_t y);
  uint8_t count_neighbours(uint8_t x, uint8_t y);
  void next_generation(CellMap& dest);
  
  TFT_eSprite* tft;
};
